﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Analyze8EX
{
    class Field
    {
        public Field(byte[] rawData, int offset)
        {
            var id = (rawData[offset] << 8) | rawData[offset + 1];
            FieldId = id & 0xFFF0;

            FieldHeaderLength = 2;
            int index = offset + FieldHeaderLength;
            var size = id & 0x000F;
            if (size == 0x0D)
            {
                size = rawData[index];
                index += 1;
                FieldHeaderLength += 1;
            }
            else if (size == 0x0E)
            {
                size = Utilities.GetBEInteger(rawData, index, 2);
                index += 2;
                FieldHeaderLength += 2;
            }
            else if (size == 0x0F)
            {
                size = Utilities.GetBEInteger(rawData, index, 4);
                index += 4;
                FieldHeaderLength += 4;
            }

            Data = new byte[size];
            Array.Copy(rawData, index, Data, 0, Data.Length);

            RawData = new byte[FieldHeaderLength + size];
            Array.Copy(rawData, offset, RawData, 0, RawData.Length);
        }

        public int FieldId { get; set; }

        public byte[] RawData { get; set; }

        public byte[] Data { get; set; }

        public int FieldHeaderLength { get; set; }

        public bool IsGroupedField
        {
            get
            {
                switch (FieldId)
                {
                    case 0x8000:
                    case 0x8100:
                        return true;
                    default:
                        return false;
                }
            }
        }
    }
}
